This website documents high-level features of the [SilverStripe open source platform](http://www.silverstripe.org), aimed
at developers.  
Please read our [guide to contributing documentation](misc/contributing#writing-documentation) if you want to help out!

### Overview

 * [Getting started](http://silverstripe.org/getting-started/) | [Feature Overview](http://silverstripe.org/introduction/) | [Demo](http://demo.silverstripe.org/)
 * [Download and Installation](installation/) | [Upgrading](/installation/upgrading) | [Requirements](/installation/server-requirements) | [Changelog](http://open.silverstripe.org/wiki/ChangeLog) | [Roadmap](http://open.silverstripe.com/roadmap)  
 * [API documentation](http://api.silverstripe.org/current) | [Official english book](http://www.silverstripe.org/silverstripe-book) | [Official german book](http://www.silverstripe.org/das-silverstripe-buch)  


###  Getting support

[Forum](http://www.silverstripe.org/forums/) | [IRC channel](http://silverstripe.org/irc) | [End user docs](http://userhelp.silverstripe.com) | [Core mailinglist](https://groups.google.com/forum/#!forum/silverstripe-dev)


### Level 1: Building your first SilverStripe website

 * [Introduction to PHP5 (zend.com)](http://devzone.zend.com/node/view/id/627)
 *  [Tutorials](tutorials)
   * [1. Building a basic site](tutorials/1-building-a-basic-site)
   * [2. Extending a basic site](tutorials/2-extending-a-basic-site)
   * [3. Forms](tutorials/3-forms)
   * [4. Site Search](tutorials/4-site-search)
   * [5. Relationships](tutorials/5-dataobject-relationship-management)
 * [Common Problems](installation/common-problems)

### Level 2: SilverStripe fundamentals

*  [Templates](topics/templates): SilverStripe has its own templating engine
*  [Themes](topics/themes): How to customize your site with themes
*  [Controllers](topics/controller): Coordination from a URL-request to finding the controller-class
*  [Pagetypes](topics/page-types): Clarifying the relationship between a page-object and a silverstripe-class
*  [Datamodel](topics/datamodel): Object-relational database model with MVC
*  [Database Structure](reference/database-structure): Breakdown of a typical SilverStripe database
*  [Datatypes](topics/data-types): Casting database-columns
*  [Forms](topics/forms): Sophisticated form generation and processing
*  [Formfield Types](reference/form-field-types): Simple and complex form-elements with built-in validation
*  [Javascript](topics/javascript)
*  [Widgets](topics/widgets)
*  [Modules](topics/modules)
*  [Configuration](topics/configuration)

### Level 3: The less obvious features

*  [Security](topics/security)
*  [Email](topics/email)
*  [RSS Feeds](reference/rssfeed)
*  [Debugging](topics/debugging)
*  [Errorhandling](topics/error-handling)
*  [Testing Guide](topics/testing/): Framework for automated testing like Unittests
*  [Built-in Page Controls](reference/built-in-page-controls)
*  [Execution Pipeline](reference/execution-pipeline): Tracking a request from director to template-rendering
*  [Recipes/Howtos](howto/)

### Level 4: Contributing to the SilverStripe core

* [Contributing](http://www.silverstripe.org/contributing-to-silverstripe/)
* [Coding Conventions](misc/coding-conventions)

<div class="hint" markdown="1">
Looking for the old DokuWiki installation? See [doc.silverstripe.org/old](http://doc.silverstripe.org/old).
</div>